diff -Nru t1lib-grace/T1lib/t1lib/t1env.c t1lib-deb/T1lib/t1lib/t1env.c
--- t1lib-grace/T1lib/t1lib/t1env.c	2002-07-29 13:37:48.000000000 -0700
+++ t1lib-deb/T1lib/t1lib/t1env.c	2007-12-23 07:49:42.000000000 -0800
@@ -1,11 +1,11 @@
 /*--------------------------------------------------------------------------
   ----- File:        t1env.c 
   ----- Author:      Rainer Menzner (Rainer.Menzner@web.de)
-  ----- Date:        2001-11-12
+  ----- Date:        2007-12-22
   ----- Description: This file is part of the t1-library. It implements
                      the reading of a configuration file and path-searching
 		     of type1-, afm- and encoding files.
-  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2001.
+  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2007.
                      As of version 0.5, t1lib is distributed under the
 		     GNU General Public Library Lincense. The
 		     conditions can be found in the files LICENSE and
@@ -74,6 +74,7 @@
 static int afm_no=-1;
 static int enc_no=-1;
 static int fdb_no=-1;
+static int fdbxlfd_no=-1;
 
 static char path_sep_char='\0';
 static char path_sep_string[2];
@@ -91,6 +92,7 @@
 static char T1_enc[]="sys$disk:[]";
 #endif
 char T1_fdb[]="FontDataBase";
+char T1_fdbxlfd[]="";  /* By default, we do not search XLFD databases. */
 
 
 /* keywords recognized in config file */
@@ -98,6 +100,7 @@
 static const char pfab_key[]="TYPE1";
 static const char afm_key[]="AFM";
 static const char fdb_key[]="FONTDATABASE";
+static const char fdbxlfd_key[]="FONTDATABASEXLFD";  
 
 
 /* qstrncpy(): Copy bytes from srcP to to destP. srcP is count bytes long
@@ -164,6 +167,12 @@
     strcpy(T1_FDB_ptr[0],T1_fdb);
     fdb_no=0;
   }
+
+  if (fdbxlfd_no==-1) {
+    /* The XLFD font data base defaults to be empty */
+    T1_FDBXLFD_ptr=(char**) calloc( 1, sizeof(char*));
+    fdbxlfd_no=0;
+  }
 }
 
 
@@ -177,39 +186,53 @@
   if (T1_PFAB_ptr!=NULL) {
     while (T1_PFAB_ptr[i]!=NULL) {
       free(T1_PFAB_ptr[i]);
-      T1_PFAB_ptr[i]=NULL;
+      T1_PFAB_ptr[i++]=NULL;
     }
     free( T1_PFAB_ptr);
+    T1_PFAB_ptr=NULL;
   }
   i=0;
   if (T1_AFM_ptr!=NULL) {
     while (T1_AFM_ptr[i]!=NULL) {
       free(T1_AFM_ptr[i]);
-      T1_AFM_ptr[i]=NULL;
+      T1_AFM_ptr[i++]=NULL;
     }
     free( T1_AFM_ptr);
+    T1_AFM_ptr=NULL;
   }
   i=0;
   if (T1_ENC_ptr!=NULL) {
     while (T1_ENC_ptr[i]!=NULL) {
       free(T1_ENC_ptr[i]);
-      T1_ENC_ptr[i]=NULL;
+      T1_ENC_ptr[i++]=NULL;
     }
     free( T1_ENC_ptr);
+    T1_ENC_ptr=NULL;
   }
   i=0;
   if (T1_FDB_ptr!=NULL) {
     while (T1_FDB_ptr[i]!=NULL) {
       free(T1_FDB_ptr[i]);
-      T1_FDB_ptr[i]=NULL;
+      T1_FDB_ptr[i++]=NULL;
     }
     free( T1_FDB_ptr);
+    T1_FDB_ptr=NULL;
+  }
+  i=0;
+  if (T1_FDBXLFD_ptr!=NULL) {
+    while (T1_FDBXLFD_ptr[i]!=NULL) {
+      free(T1_FDBXLFD_ptr[i]);
+      T1_FDBXLFD_ptr[i++]=NULL;
+    }
+    free( T1_FDBXLFD_ptr);
+    T1_FDBXLFD_ptr=NULL;
   }
   /* indicate t1lib non-initialized */
   pfab_no=-1;
   afm_no=-1;
   enc_no=-1;
   fdb_no=-1;
+  fdbxlfd_no=-1;
   
   return;
 }
@@ -242,7 +265,7 @@
   env_str=getenv(ENV_CONF_STRING);
   linecnt=1;
 
-  if (env_str==NULL) {
+  if (!env_str) {
     /* environment variable not set, try to open default file
        in user's home directory and afterwards global config file */
     if ((usershome=getenv("HOME"))!=NULL) {
@@ -285,7 +308,7 @@
       }
       else{
 	sprintf( err_warn_msg_buf, "Using %s as Configfile (global)",
-		 cnffilepath);
+		 globalcnffilepath);
 	T1_PrintLog( "ScanConfigFile()", err_warn_msg_buf, T1LOG_STATISTIC);
       }
     }
@@ -358,7 +381,7 @@
       idestP=&enc_no;
       curr_key=(char*)enc_key;
     }
-    else if (strncmp( "TYPE1", &linebuf[j], 5)==0) {
+    else if (strncmp( pfab_key, &linebuf[j], 5)==0) {
       /* setup target */
       destP=&T1_PFAB_ptr;
       idestP=&pfab_no;
@@ -370,6 +393,23 @@
       idestP=&afm_no;
       curr_key=(char*)afm_key;
     }
+    else if (strncmp( fdbxlfd_key, &linebuf[j], 16)==0) {
+      /* The handling here is somewhat specific. XLFD font database
+	 specifications may coexist with standard font database
+	 specification. However, if the standard font database is
+	 the default value, an existing XLFD specification clears
+	 this default value. Let this precede the standard fdb because
+	 otherwise, this code would never be reached. */
+      if (fdb_no==0) { /* default paths are currently setup, get rid of them */
+	free(T1_FDB_ptr[0]);
+	T1_FDB_ptr[0]=NULL;
+      }
+      
+      /* setup target */
+      destP=&T1_FDBXLFD_ptr;
+      idestP=&fdbxlfd_no;
+      curr_key=(char*)fdbxlfd_key;
+    }
     else if (strncmp( fdb_key, &linebuf[j], 12)==0) {
       /* setup target */
       destP=&T1_FDB_ptr;
@@ -386,7 +426,10 @@
     if (ignoreline==0) { 
       /* Check for an explicitly assigned value */
       if (*idestP==0) { /* default paths are currently setup, get rid of them */
-	free((*destP)[0]);
+	if ((*destP)[0]!=NULL) {
+	  free((*destP)[0]);
+	  (*destP)[0]=NULL;
+	}
       }
       else { /* append to existing paths */
 	T1_PrintLog( "ScanConfigFile()",
@@ -558,7 +601,7 @@
     /* cut a trailing directory separator */
     j=strlen(pathbuf);
     if (pathbuf[j-1]==DIRECTORY_SEP_CHAR)
-      pathbuf[j--]='\0';
+      pathbuf[--j]='\0';
     /* Add the directory separator: */
 #ifdef VMS
     { char *p= strrchr(pathbuf, DIRECTORY_SEP_CHAR);
@@ -567,7 +610,24 @@
     } 
 #endif 
     strcat( pathbuf, DIRECTORY_SEP);
-    /* And finally the filename: */
+    /* And finally the filename.
+       The following is fix against a vulnerability given by passing in
+       large filenames, cf.:
+
+           http://www.securityfocus.com/bid/25079
+
+       or
+
+           http://packetstormsecurity.nl/0707-advisories/t1lib.txt
+
+       If current pathbuf + StrippedName + 1 byte for NULL is bigger than
+       pathbuf log a warning and try next pathbuf */
+    if ( strlen(pathbuf) + strlen(StrippedName) + 1 > sizeof(pathbuf) ) {
+      T1_PrintLog( "intT1_Env_GetCompletePath()", "Omitting suspicious long candidate path in order to prevent buffer overflow.",
+		   T1LOG_WARNING);
+      i++;
+      continue;
+    }
     strcat( pathbuf, StrippedName);
     
     /* Check for existence of the path: */
@@ -620,7 +680,7 @@
 
   /* We do not allow to change the searchpath if the database already
      contains one or more entries. */
-  if (T1_Get_no_fonts()>0){
+  if (T1_GetNoFonts()>0){
     sprintf( err_warn_msg_buf, "Path %s not set, database is not empty",
 	     pathname);
     T1_PrintLog( "T1_SetFileSearchPath()", err_warn_msg_buf,
@@ -769,15 +829,14 @@
 {
   int i;
   int pathlen;
-  char* newpath;
+  char* newpath = NULL;
   int nofonts;
   
   
-  
   if (pathname==NULL)
     return(-1);
 
-  nofonts=T1_Get_no_fonts();
+  nofonts=T1_GetNoFonts();
   
   pathlen=strlen(pathname);
   
@@ -895,6 +954,11 @@
     }
     T1_ENC_ptr[enc_no]=NULL;
   }
+  
+  /* Copy new path to where it belongs ... */
+  if (newpath)
+    strcpy(newpath, pathname);
+  
   return(0);
   
 }
@@ -953,7 +1017,7 @@
   fdb_no=1;
 
   /* Load database immediately if t1lib already is initailzed */
-  if (CheckForInit()==0) {
+  if (T1_CheckForInit()==0) {
     if ((result=intT1_scanFontDBase(T1_FDB_ptr[0]))==-1) {
       T1_PrintLog( "T1_AddFontDataBase()", "Fatal error scanning Font Database File %s (T1_errno=%d)",
 		   T1LOG_WARNING, T1_FDB_ptr[0], T1_errno);
@@ -1011,7 +1075,7 @@
   }
   /* Insert the new database. If t1lib is already initialzed, the database can only
      be appended. Otherwise. prepending is also possible.*/
-  if ((mode & T1_PREPEND_PATH) && (CheckForInit()!=0) ) { /* prepend */
+  if ((mode & T1_PREPEND_PATH) && (T1_CheckForInit()!=0) ) { /* prepend */
     i=fdb_no-2;
     while (i>=0) {
       T1_FDB_ptr[i+1]=T1_FDB_ptr[i];
@@ -1022,7 +1086,7 @@
   }
   else { /* append */
     T1_FDB_ptr[fdb_no-1]=newpath;
-    if (CheckForInit()==0) {
+    if (T1_CheckForInit()==0) {
       if ((result=intT1_scanFontDBase(T1_FDB_ptr[fdb_no-1]))==-1) {
 	T1_PrintLog( "T1_AddFontDataBase()", "Fatal error scanning Font Database File %s (T1_errno=%d)",
 		     T1LOG_WARNING, T1_FDB_ptr[fdb_no-1], T1_errno);
@@ -1036,5 +1100,144 @@
   return result;
   
 }
+
+
+
+/* T1_SetFontDataBaseXLFD(): Set a new name for the XLFD font database. It
+   replaces the default name (which is empty and any names specified
+   previously with this function.
+   Return value: 0 if OK, and -1 if filename not valid or an allocation
+   error occurred */
+int T1_SetFontDataBaseXLFD( char *filename)
+{
+  int pathlen;
+  int i;
+  int result=0;
+  
+  
+  /* check filename */
+  if (filename==NULL) {
+    T1_errno=T1ERR_INVALID_PARAMETER;
+    return -1;
+  }
+
+  /* this function must be called before any font is in the database, that is, usually,
+     before initialization! */
+  if ( pFontBase!=NULL && pFontBase->no_fonts>0) {
+    T1_errno=T1ERR_OP_NOT_PERMITTED;
+    return -1;
+  }
+
+  
+  pathlen=strlen(filename)+1;
+  /* Throw away a possibly existing font database-statement */
+  if (fdbxlfd_no==-1) {  
+    T1_FDBXLFD_ptr=NULL; /* realloc() will do a malloc() */
+  }
+  else { 
+    /* throw away current paths */
+    i=0;
+    while (T1_FDBXLFD_ptr[i]!=NULL) {
+      free (T1_FDBXLFD_ptr[i++]);
+    }
+  }
+
+  if ((T1_FDBXLFD_ptr=(char**)realloc( T1_FDBXLFD_ptr, 2*sizeof(char*)))==NULL) {
+    T1_errno=T1ERR_ALLOC_MEM;
+    return -1;
+  }
+  
+  if ((T1_FDBXLFD_ptr[0]=(char*)malloc(pathlen*sizeof(char)))==NULL) {
+    T1_errno=T1ERR_ALLOC_MEM;
+    return -1;
+  }
+  strcpy( T1_FDBXLFD_ptr[0], filename);
+  T1_FDBXLFD_ptr[1]=NULL;
+  fdb_no=1;
+
+  /* Load XLFD database immediately if t1lib already is initailzed */
+  if (T1_CheckForInit()==0) {
+    if ((result=intT1_scanFontDBaseXLFD(T1_FDBXLFD_ptr[0]))==-1) {
+      T1_PrintLog( "T1_AddFontDataBaseXLFD()", "Fatal error scanning XLFD Font Database File %s (T1_errno=%d)",
+		   T1LOG_WARNING, T1_FDBXLFD_ptr[0], T1_errno);
+    }
+    if (result>-1)
+      pFontBase->no_fonts+=result;
+    result=pFontBase->no_fonts;
+  }
+  return result;
+  
+}
+
+
+/* T1_AddFontDataBaseXLFD(): Add a new XLFD font database file to the list. If
+   the lib is already initialzed, then the new database is immediately loaded.
+   Otherwise it is simply appended to the list and loaded at the time of
+   initialization.
+   Returns: -1    an error occured
+             0    successfully inserted but not loaded because lib not initilized
+	     n>0  the highest defined FontID
+*/
+int T1_AddFontDataBaseXLFD( int mode, char *filename) 
+{
+  int i;
+  int pathlen;
+  int result=0;
+  char* newpath;
+  
+  
+  if (filename==NULL) {
+    T1_errno=T1ERR_INVALID_PARAMETER;
+    return(-1);
+  }
+  
+  pathlen=strlen(filename);
+  
+  /* Allocate memory for string */
+  if ((newpath=(char*)malloc( (pathlen+1)*sizeof(char)))==NULL)  {
+    T1_errno=T1ERR_ALLOC_MEM;
+    return(-1);
+  }
+  strcpy( newpath, filename);
+  /* Check for and handle the existing path configuration */
+  if (fdb_no==0) {   /* defauls setup, free the path */
+    free( T1_FDB_ptr[0]);
+  }
+  if (fdbxlfd_no==-1) {  /* not initialized! */
+    fdbxlfd_no=0;
+    T1_FDBXLFD_ptr=NULL; /* realloc() will do the malloc()! */
+  }
+  
+  if ((T1_FDBXLFD_ptr=(char**)realloc( T1_FDBXLFD_ptr, (++fdbxlfd_no+1)*sizeof(char*)))==NULL) {
+    T1_errno=T1ERR_ALLOC_MEM;
+    return(-1);
+  }
+  /* Insert the new database. If t1lib is already initialzed, the database can only
+     be appended. Otherwise. prepending is also possible.*/
+  if ((mode & T1_PREPEND_PATH) && (T1_CheckForInit()!=0) ) { /* prepend */
+    i=fdbxlfd_no-2;
+    while (i>=0) {
+      T1_FDBXLFD_ptr[i+1]=T1_FDBXLFD_ptr[i];
+      i--;
+    }
+    T1_FDBXLFD_ptr[0]=newpath;
+    result=0;
+  }
+  else { /* append */
+    T1_FDBXLFD_ptr[fdbxlfd_no-1]=newpath;
+    if (T1_CheckForInit()==0) {
+      if ((result=intT1_scanFontDBaseXLFD(T1_FDBXLFD_ptr[fdbxlfd_no-1]))==-1) {
+	T1_PrintLog( "T1_AddFontDataBase()", "Fatal error scanning Font Database File %s (T1_errno=%d)",
+		     T1LOG_WARNING, T1_FDBXLFD_ptr[fdbxlfd_no-1], T1_errno);
+      }
+      if (result>-1)
+	pFontBase->no_fonts+=result;
+      result=pFontBase->no_fonts;
+    }
+  }
+  T1_FDBXLFD_ptr[fdbxlfd_no]=NULL;
+  return result;
+  
+}
 
 
diff -Nru t1lib-grace/T1lib/t1lib/t1env.h t1lib-deb/T1lib/t1lib/t1env.h
--- t1lib-grace/T1lib/t1lib/t1env.h	2002-01-03 13:15:15.000000000 -0800
+++ t1lib-deb/T1lib/t1lib/t1env.h	2007-12-23 07:49:42.000000000 -0800
@@ -1,10 +1,10 @@
 /*--------------------------------------------------------------------------
   ----- File:        t1env.h
   ----- Author:      Rainer Menzner (Rainer.Menzner@web.de)
-  ----- Date:        2001-09-26
+  ----- Date:        2005-05-16
   ----- Description: This file is part of the t1-library. It contains
                      declarations and definitions for t1env.c
-  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2001. 
+  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2005.
                      As of version 0.5, t1lib is distributed under the
 		     GNU General Public Library Lincense. The
 		     conditions can be found in the files LICENSE and
@@ -37,6 +37,8 @@
 char *T1_GetFileSearchPath( int type);
 int T1_SetFontDataBase( char *filename);
 int T1_AddFontDataBase( int mode, char *filename);
+int T1_SetFontDataBaseXLFD( char *filename);
+int T1_AddFontDataBaseXLFD( int mode, char *filename);
 
 #else
 
@@ -49,6 +51,8 @@
 extern char *T1_GetFileSearchPath( int type);
 extern int T1_SetFontDataBase( char *filename);
 extern int T1_AddFontDataBase( int mode, char *filename);
+extern int T1_SetFontDataBaseXLFD( char *filename);
+extern int T1_AddFontDataBaseXLFD( int mode, char *filename);
 
 #endif
 
diff -Nru t1lib-grace/T1lib/t1lib/t1extern.h t1lib-deb/T1lib/t1lib/t1extern.h
--- t1lib-grace/T1lib/t1lib/t1extern.h	2002-01-03 13:15:15.000000000 -0800
+++ t1lib-deb/T1lib/t1lib/t1extern.h	2007-12-23 07:49:42.000000000 -0800
@@ -1,10 +1,10 @@
 /*--------------------------------------------------------------------------
   ----- File:        t1extern.h
   ----- Author:      Rainer Menzner (Rainer.Menzner@web.de)
-  ----- Date:        2001-10-03
+  ----- Date:        2005-05-16
   ----- Description: This file is part of the t1-library. It contains
                      external declarations used by the t1-library.
-  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2001. 
+  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2005.
                      As of version 0.5, t1lib is distributed under the
 		     GNU General Public Library Lincense. The
 		     conditions can be found in the files LICENSE and
@@ -89,6 +89,7 @@
 extern char **T1_AFM_ptr;
 extern char **T1_ENC_ptr;
 extern char **T1_FDB_ptr;
+extern char **T1_FDBXLFD_ptr;
 
 /* We use a uchar buffer for error and warning messages: */
 extern char err_warn_msg_buf[1024];
diff -Nru t1lib-grace/T1lib/t1lib/t1finfo.c t1lib-deb/T1lib/t1lib/t1finfo.c
--- t1lib-grace/T1lib/t1lib/t1finfo.c	2002-01-03 13:15:15.000000000 -0800
+++ t1lib-deb/T1lib/t1lib/t1finfo.c	2007-12-23 07:49:42.000000000 -0800
@@ -1,11 +1,11 @@
 /*--------------------------------------------------------------------------
   ----- File:        t1finfo.c 
   ----- Author:      Rainer Menzner (Rainer.Menzner@web.de)
-  ----- Date:        2001-06-10
+  ----- Date:        2005-05-01
   ----- Description: This file is part of the t1-library. It contains
                      functions for accessing afm-data and some other
 		     fontinformation data.
-  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2001. 
+  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2005. 
                      As of version 0.5, t1lib is distributed under the
 		     GNU General Public Library Lincense. The
 		     conditions can be found in the files LICENSE and
@@ -51,6 +51,7 @@
 #include "../type1/spaces.h"
 #include "../type1/util.h"
 #include "../type1/fontfcn.h"
+#include "../type1/paths.h"
 #include "../type1/regions.h"
 
 
@@ -89,7 +90,7 @@
   
 
   /* Check whether font is loaded: */
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(0);
   }
@@ -131,7 +132,7 @@
   uchar1=(unsigned char) char1;
   
   /* Check whether font is loaded: */
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(0);
   }
@@ -195,7 +196,7 @@
   uchar1=(unsigned char) char1;
   
   /* Check whether font is loaded: */
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(NullBBox);
   }
@@ -228,7 +229,7 @@
 		   pFontBase->pFontArray[FontID].pFontEnc,
 		   (int) uchar1, &mode,
 		   pFontBase->pFontArray[FontID].pType1Data,
-		   DO_RASTER);
+		   DO_RASTER,0.0f);
     /* Read out bounding box */
     ResultBox.llx =area->xmin;
     ResultBox.urx =area->xmax;
@@ -273,7 +274,7 @@
    is not yet loaded into memory. or an invalid ID has been specified. */
 float T1_GetUnderlinePosition( int FontID)
 {
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(0.0);
   }
@@ -288,7 +289,7 @@
    is not yet loaded into memory. or an invalid ID has been specified. */
 float T1_GetUnderlineThickness( int FontID)
 {
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(0.0);
   }
@@ -302,7 +303,7 @@
    is not yet loaded into memory. or an invalid ID has been specified. */
 float T1_GetItalicAngle( int FontID)
 {
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(0.0);
   }
@@ -317,7 +318,7 @@
    is not yet loaded into memory. or an invalid ID has been specified. */
 int T1_GetIsFixedPitch( int FontID)
 {
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(0.0);
   }
@@ -334,7 +335,7 @@
 {
   static char fontname[MAXPSNAMELEN];
   
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(NULL);
   }
@@ -356,7 +357,7 @@
 {
   static char fullname[MAXPSNAMELEN];
   
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(NULL);
   }
@@ -378,7 +379,7 @@
 {
   static char familyname[MAXPSNAMELEN];
   
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(NULL);
   }
@@ -400,7 +401,7 @@
 {
   static char weight[128];
   
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(NULL);
   }
@@ -422,7 +423,7 @@
 {
   static char version[2048];
   
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(NULL);
   }
@@ -444,7 +445,7 @@
 {
   static char notice[2048];
   
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(NULL);
   }
@@ -469,7 +470,7 @@
   char *c1;
   
 
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(NULL);
   }
@@ -518,7 +519,7 @@
   int i,j;
   
   /* Check whether font is loaded: */
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(-1);
   }
@@ -600,7 +601,7 @@
   psobj *objptr;
   
   
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(-1);
   }
@@ -654,7 +655,7 @@
   static int indices[257];
 
   
-  if (CheckForFontID(FontID)!=1) {
+  if (T1_CheckForFontID(FontID)!=1) {
     T1_errno=T1ERR_INVALID_FONTID;
     return(NULL);
   }
@@ -711,7 +712,7 @@
   ustring=(unsigned char *) string;
   
   /* First, check for a correct ID */
-  i=CheckForFontID(FontID);
+  i=T1_CheckForFontID(FontID);
   if (i!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(0);
@@ -733,52 +734,76 @@
   else        /* use value given on command line */
     no_chars=len;
 
-  /* Allocate room for temporary arrays of kerning and width arrays: */
-  kern_pairs=(int *)calloc(no_chars -1, sizeof(int));
-  if (kern_pairs==NULL){
-    T1_errno=T1ERR_ALLOC_MEM;
-    return(0);
-  }
-  charwidths=(int *)calloc(no_chars, sizeof(int));
-  if (charwidths==NULL){
-    T1_errno=T1ERR_ALLOC_MEM;
-    return(0);
-  }
+  switch (no_chars) {
+    case 0:
+      /* Empty string has width 0 */
+      stringwidth=0;
+      break;
+
+    case 1:
+      /* Width of string with 1 character is the width of that character.
+         If the character is a space, adjust by the value of spaceoff.
+         */
+      stringwidth=T1_GetCharWidth(FontID,ustring[0]);
+      if (ustring[0]==pFontBase->pFontArray[FontID].space_position)
+        stringwidth+=spaceoff;
+      break;
+
+    default:
+      /* Two or more characters.  Add widths of characters and adjust by
+         the adjustment widths for any kerning pairs.  For spaces, use the
+         width of the space character in the font adjusted by the value of
+         spaceoff.
+         */
+    
+      /* Allocate room for temporary arrays of kerning and width arrays: */
+      kern_pairs=(int *)calloc(no_chars -1, sizeof(int));
+      if (kern_pairs==NULL){
+        T1_errno=T1ERR_ALLOC_MEM;
+        return(0);
+      }
+      charwidths=(int *)calloc(no_chars, sizeof(int));
+      if (charwidths==NULL){
+        T1_errno=T1ERR_ALLOC_MEM;
+        return(0);
+      }
   
-  /* If kerning is requested, get kerning amounts and fill the array: */
-  if (kerning){
-    for (i=0; i<no_chars -1; i++){
-      kern_pairs[i]=T1_GetKerning( FontID, ustring[i], ustring[i+1]);
-    }
-  }
+      /* If kerning is requested, get kerning amounts and fill the array: */
+      if (kerning){
+        for (i=0; i<no_chars -1; i++){
+          kern_pairs[i]=T1_GetKerning( FontID, ustring[i], ustring[i+1]);
+        }
+      }
   
-  /* Compute the correct spacewidth value (in charspace units): */
-  spacewidth=T1_GetCharWidth(FontID,pFontBase->pFontArray[FontID].space_position)+spaceoff;
+      /* Compute the correct spacewidth value (in charspace units): */
+      spacewidth=T1_GetCharWidth(FontID,pFontBase->pFontArray[FontID].space_position)+spaceoff;
   
-  /* Fill the width-array:  */
-  for (i=0; i<no_chars; i++){
-    if (ustring[i]==pFontBase->pFontArray[FontID].space_position)
-      charwidths[i]=(int)spacewidth;
-    else
-      charwidths[i]=T1_GetCharWidth(FontID,ustring[i]);
-  }
+      /* Fill the width-array:  */
+      for (i=0; i<no_chars; i++){
+        if (ustring[i]==pFontBase->pFontArray[FontID].space_position)
+          charwidths[i]=(int)spacewidth;
+        else
+          charwidths[i]=T1_GetCharWidth(FontID,ustring[i]);
+      }
   
-  /* Accumulate width: */
-  stringwidth=0;
-  for (i=0; i<no_chars-1; i++){
-    stringwidth += kern_pairs[i];
-  }
-  for (i=0; i<no_chars; i++){
-    stringwidth += charwidths[i];
-  }
+      /* Accumulate width: */
+      stringwidth=0;
+      for (i=0; i<no_chars-1; i++){
+        stringwidth += kern_pairs[i];
+      }
+      for (i=0; i<no_chars; i++){
+        stringwidth += charwidths[i];
+      }
   
-  /* free memory: */
-  free( charwidths);
-  free( kern_pairs);
+      /* free memory: */
+      free( charwidths);
+      free( kern_pairs);
+
+      break;
+  }
 
   /* .. and return result: */
   return( stringwidth);
-
 }
 
     
@@ -808,7 +833,7 @@
 
   
   /* First, check for a correct ID */
-  i=CheckForFontID(FontID);
+  i=T1_CheckForFontID(FontID);
   if (i!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(NullBBox);
@@ -902,7 +927,7 @@
 
 
   /* First, check for a correct ID */
-  i=CheckForFontID(FontID);
+  i=T1_CheckForFontID(FontID);
   if (i!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(metrics);
@@ -977,7 +1002,7 @@
   struct ps_obj *obj;
 
   /* return Null-box if font not loaded */
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(outbox);
   }
@@ -1019,7 +1044,7 @@
   int bufmemsize=0;
   
   /* return NULL if font not loaded */
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return( NULL);
   }
@@ -1077,7 +1102,7 @@
 {
   
   /* Check whether font is loaded: */
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return( -1);
   }
@@ -1116,7 +1141,7 @@
 {
   
   /* Check whether font is loaded: */
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return( -1);
   }
@@ -1151,7 +1176,7 @@
   uchar1=char1;
   
   /* Check whether font is loaded: */
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return( -2);
   }
@@ -1184,7 +1209,7 @@
   unsigned char uchar1;
   
   /* Check whether font is loaded: */
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return( cci);
   }
@@ -1253,7 +1278,7 @@
   int i;
   
   /* Check whether font is loaded: */
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return( cci);
   }
@@ -1312,7 +1337,7 @@
   int len, i, j;
   
   /* return NULL if font not loaded */
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return( -1);
   }
diff -Nru t1lib-grace/T1lib/t1lib/t1global.h t1lib-deb/T1lib/t1lib/t1global.h
--- t1lib-grace/T1lib/t1lib/t1global.h	2002-01-03 13:15:15.000000000 -0800
+++ t1lib-deb/T1lib/t1lib/t1global.h	2007-12-23 07:49:42.000000000 -0800
@@ -1,7 +1,7 @@
 /*--------------------------------------------------------------------------
   ----- File:        t1global.h
   ----- Author:      Rainer Menzner (Rainer.Menzner@web.de)
-  ----- Date:        2001-04-01
+  ----- Date:        2005-05-16
   ----- Description: This file is part of the t1-library. It contains
                      global declarations used by the t1-library.
   ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2001. 
@@ -99,6 +99,7 @@
 char** T1_AFM_ptr=NULL;
 char** T1_ENC_ptr=NULL;
 char** T1_FDB_ptr=NULL;
+char** T1_FDBXLFD_ptr=NULL;
 
 /* We use a uchar buffer for error and warning messages: */
 char err_warn_msg_buf[1024];
